% === noise_generation.m ===    ===
clc
clear all

T = 5;    %   , 
Fs = 22050; %  , 

color_noise = [1 1 1 1 1 1 1;2*sqrt(2) 2 sqrt(2) 1 1/sqrt(2) 1/2 1/2/sqrt(2);...
    8 4 2 1 1/2 1/4 1/8];
% color_noise(color,:) -  : color =1; : =2;  : =3

%  -   ---
load fltrbnk7_struct;
a = fltrbnk7_struct.a;
len_a = fltrbnk7_struct.len_a;

N = T*Fs+len_a;

for color = 1:3
    color_n = color_noise(color,:); 
    disp(['color = ' num2str(color)]);
    %  : color =1; : =2;  : =3

    %    () ---
    n = randn(N,1);    %    ()
    nband = filter_band_7_func(n,a,color_n);   %  
    nband(1:len_a,:)=[];            %   
    noise = sum(nband,2);
    noise = noise/max(abs(noise));
        if color == 1
           temptab = struct(['n' num2str(color)], noise);
        else
           temptab.(['n' num2str(color)]) = noise;
        end
    [Pnn,f] = pwelch(noise,rectwin(4096),2048,4096,22050);
    figure; plot(f,10*log10(Pnn));
    xlabel(', '); ylabel(' , ');
    grid on; title(['  ' num2str(color)]);
end
temptab.('fs') = 22050;
save ('noises_table.mat', '-struct', 'temptab');