% === t60_shroeder_2.m ===     -  2===
%       
%  -
clc
clear all

[h,Fs]=wavread('rir_3p0.wav');  %  
len_h = length(h);  %  
% ===  1:     ===
% ===   ===
t1=1/Fs:1/Fs:len_h/Fs;
h2=h.^2;h2=h2/max(h2);
figure; plot(t1,10*log10(abs(h2))); grid on; hold on
% ===     ===
tic;   %    
R=flipud(filter(1/Fs,[1 -1],flipud(h2)));   % 
R = 10*log10(R/max(R));
plot(t1,R,'r','LineWidth',2);
toc;   %    
% ===  2:    ===
% ===    ===
por1=-1; por11=-11; por5=-5; por35=-35; por25=-25; por15=-15; 
% ===     1  ===
T1 = find(diff(sign(R-por1)))/Fs;
% ===     11  ===
T11 = find(diff(sign(R-por11)))/Fs;
% ===     5  ===
T5 = find(diff(sign(R-por5)))/Fs;
% ===     35  ===
T35 = find(diff(sign(R-por35)))/Fs;
% ===     25  ===
T25 = find(diff(sign(R-por25)))/Fs;
% ===     15  ===
T15 = find(diff(sign(R-por15)))/Fs;
% ===  T60 ===
T30 = (T35-T5)*2; T20 = (T25-T5)*3; T10 = (T15-T5)*6; EDT = (T11-T1)*6;
title(['T_3_0 = ' num2str(T30) ',T_2_0 = ' num2str(T20) ',T_1_0 = ' num2str(T10) ',EDT = ' num2str(EDT)],'FontSize',14);
xlabel(', ','FontSize',14); ylabel(', ','FontSize',14);
