% === table_reading.m ===   ===
%
%    -    
%    3-  ()  
%
%                            :
%
% 1.  5    :
%    1.1.     "Rezults_Surname",  Surname -
%     
%    1.2. 4- ,    ,   
%      
%
% 2.      params:
% :
% params.n = 1;     -     (0 -  )
% params.r = 1; -     (0 -  )
% params.snr0 = 0;  -   -   
% params.fs = 22050;   -    22050 
% noises = load('noises_table.mat');   -   
% params.noise = noises.n1   -    
% rirs = load('rirs_table.mat'); -   .- 
% params.rir = rirs.rir_0p9; -   .- 
%
% 3.  wav-   
% :
% sig = load('wav_table_13.mat');   -  wav-  13
%
% 4.      wav-
%	4.1.     (, , inputSignal = sig.w2;)
%   4.2.  : [ outputSignal ] = distorSystem( inputSignal, params );
%	4.3.  : soundsc(outputSignal,params.fs);
%   4.4.     (mat-)
% ʳ 
% 5. ϳ    
%
%                       
%-------------------------------------------------------------------------
%       |  ʳ-  | 
%    | * |                  C 
% ||
% ------------------------------------------------------------------------
%    1    |  13   |  
%    2    |  93   | .: 1)  ; 2) snr0 ()= +10; 0; -10
%    3    |  73   | . -: T60 () = 0.3; 0.6; 0.9; 1.1; 1.4; 2; 2.7
%    4    |  93   |   ()  :
%         |        |   T60(c) = 0.3;   snr0(dB) = -10; 0; +10
%         |        |   T60(c) = 0.6;   snr0(dB) = -10; 0; +10
%         |        |   T60(c) = 1.1;   snr0(dB) = -10; 0; +10
%
% *:     3  
%
% Copyright @ .,  2017

clc         %   
clear all   %     , .. workspace

nums = 5; %   (  50,  5 -  )
lastname = input('     :   ');

% 1.  5    :
kat_rezults = ['Rezults_' lastname];   % '    
mkdir(kat_rezults);       %      
mkdir([kat_rezults '\Group1']);% .   - 1-  
mkdir([kat_rezults '\Group2']);% .   - 2-  
mkdir([kat_rezults '\Group3']);% .   - 3-  
mkdir([kat_rezults '\Group4']);% .   - 4-  

addpath ([kat_rezults '\Group1'],[kat_rezults '\Group2'],...
    [kat_rezults '\Group3'],[kat_rezults '\Group4']);

clc
disp('Ӫ   ˲Ĳ:');
disp(' 1 -  :');
disp(' 2 -   :');
disp(' 3 -   :');
disp(' 4 -     :');
disp(' ');

m = input('   :    ');
disp(' ');

% 2.      params:
switch m
    case 1
        params.n = 0;
        params.r = 0;
        params.fs = 22050;   %    22050 
    case 2
        params.n = 1;
        params.r = 0;
        disp('   SNR  : 10, 0  -10');
        params.snr0 = input('   SNR:   '); 
        params.fs = 22050;   %    22050 
        noises = load('noises_table.mat');   %   
        ncolor = input('   (1 - .; 2 - .; 3 - .)   ');
        color = ['n' num2str(ncolor)];
        params.noise = noises.(color);
    case 3
        params.n = 0;
        params.r = 1;
        params.fs = 22050;   %    22050         
        rirs = load('rirs_table.mat'); %   .- 
        disp('  T60: 0p3, 0p6  1p1');
        t60 = input('   T60  :   ');
        fieldname = ['rir_' t60];
        params.rir = rirs.(fieldname);
    case 4
        params.n = 1;
        params.r = 1;
        disp('  SNR  : 10, 0  -10');
        params.snr0 = input('   SNR:   ');
        params.fs = 22050;   %    22050 
        noises = load('noises_table.mat');   %   
        ncolor = 2;                          %  
        color = ['n' num2str(ncolor)];
        params.noise = noises.(color);
        rirs = load('rirs_table.mat'); %   .- 
        disp('  T60: 0p3, 0p6  1p1');
        t60 = input('   T60  :   ');
        fieldname = ['rir_' t60];
        params.rir = rirs.(fieldname);
        
end

% 3.    
N = input('  :      '); %   
rfr1_tablename = ['rfr_table_' num2str(N) '_1.mat'];% ' 1- .
rfr2_tablename = ['rfr_table_' num2str(N) '_2.mat'];% ' 2- .
wav_tablename = ['wav_table_' num2str(N) '.mat'];          % ' wav-
wavs = load(wav_tablename);   %  wav-
if m == 1                %     
    suf = ''; 
elseif m == 2
    suf = ['_clr' num2str(ncolor) 'snr' num2str(params.snr0)];
elseif m == 3
    suf = ['_t' num2str(t60)];
else
    suf = ['_clr' num2str(ncolor) 'snr' num2str(params.snr0) 't' num2str(t60)];
end
rzlt_tablename = ['rzlt_table_' num2str(N) suf '.mat'];% '  

% 4.   (   )
clc
disp(['    ' num2str(N)]);
disp(' ');
for k = 1:nums
    inputSignal = wavs.(['w' num2str(k)]);
    params.m = m;
    [outputSignal] = distorSystem(inputSignal, params);
    soundsc(outputSignal,params.fs);
    symb = input('     :    ');
    temprzlt.(['s' num2str(k)]) = symb;
    katname = [kat_rezults '\Group' num2str(m) '\' rzlt_tablename];
    save (katname, '-struct', 'temprzlt');
end

% 5. ϳ    
rfrtbl_1 = load(rfr1_tablename); %  1- .
rfrtbl_2 = load(rfr2_tablename); %  2- .
num_right = 0;        %     
clc
disp(' ϲ   ');
disp(' ');
disp([' 1 ' '  2 ' '  ']);
disp(' ');
for k1 = 1:nums
    fldname = ['s' num2str(k1)];
    ref1 = rfrtbl_1.(fldname);
    ref2 = rfrtbl_1.(fldname);
    rzlt = temprzlt.(fldname);
    disp([ref1 '        ' ref2 '         ' rzlt]);
    if ((strcmp(rzlt, ref1))||(strcmp(rzlt, ref2)))
        num_right = num_right + 1;
    end
end
corct = num_right/nums;
disp(' ');
disp([' : ' num2str(num_right) '  ' num2str(nums)]);
disp(['  : ' num2str(corct)]);

%         
%  
temprzlt.('corct') = corct;
katname = [kat_rezults '\Group' num2str(m) '\' rzlt_tablename];
save (katname, '-struct', 'temprzlt');
