function detVoice = vad_LP(inputSignal, fs)
% simple Voice Activity Detector %
% 1)     ".-"
% 2)  

% Copyright @ , , - 2017

inputSignal = inputSignal - mean(inputSignal); %  
%ls = length(inputSignal);

tay = 0.05;                            %    
N = round(tay*fs);                           %    
%t = 0 : 1/fs : (ls-1)/fs;             %   

% 1)     ".-"
ak = 1/N*ones(1,N);  %  .   
y = filter(ak,1,abs(inputSignal));    %  

%subplot(2,1,1)
%plot(t,inputSignal,'g',t,y,'r','Linewidth',1);
%grid on; title('Input signal')
%xlabel('Time, sec'); ylabel('Amplitude')
%axis([0 (ls-1)/fs -1 1])

% 2)  
noise = [inputSignal(1:2*N); inputSignal(end-2*N:end)];    % 
sig_noise = std(noise);               %   
threshold = 3*sig_noise;              %  

detVoice = (sign(y-threshold)+1)/2;

%subplot(2,1,2)
%plot(t,detVoice,'r','Linewidth',1); 
%grid on; title('Detector');
%xlabel('Time, sec'); ylabel('Amplitude');
%axis([0 (ls-1)/fs -0.1 1.1])


